[![Build Status](https://travis-ci.org/DeadlyBossMods/DeadlyBossMods.svg?branch=master)](https://travis-ci.org/DeadlyBossMods/DeadlyBossMods)
[![DeadlyBossMods on Discord](https://img.shields.io/badge/discord-DeadlyBossMods-738bd7.svg?style=flat)](https://discord.gg/DeadlyBossMods) 

[![Patreon](https://media.forgecdn.net/attachments/76/25/patreon-medium-button.png)](https://www.patreon.com/deadlybossmods)

# Deadly Boss Mods
### [Supporter Benefits](https://www.deadlybossmods.com/forum/viewtopic.php?f=7&t=428#p1180)
### [Some basic DBM setup/advanced features guides](https://www.deadlybossmods.com/forum/viewforum.php?f=7)

## Old Content mods are split into multiple packages
Older content is split into multiple addons to reduce mod update size. These are often far less updated as DBM Core packages and are better as optional extra packages. You can get them here:
* [Legion Raid Mods](https://curseforge.com/wow/addons/deadly-boss-mods-dbm-legion)
* [Warlords of Draenor Raid Mods](https://curseforge.com/wow/addons/deadly-boss-mods-wod)
* [Mists of Pandaria Raid Mods](https://curseforge.com/wow/addons/deadly-boss-mods-mop)
* [Cataclysm Raid Mods](https://curseforge.com/wow/addons/deadly-boss-mods-cataclysm-mods)
* [Wrath of the Lich King Raid Mods](https://curseforge.com/wow/addons/deadly-boss-mods-wotlk)
* [Burning Cruisade and Vanilla Raid Mods](https://curseforge.com/wow/addons/dbm-bc)
* [5 man Dungeon Mods](https://curseforge.com/wow/addons/deadly-boss-mods-dbm-dungeons)

## Additional Mods
* [Event Sound Pack](https://curseforge.com/wow/addons/deadly-boss-mods-dbm-event-sound-pack)
* [SpellTimers](https://curseforge.com/wow/addons/dbm-spelltimers)
* [DBM-Archeology](https://curseforge.com/wow/addons/dbm-archaeology)
* [DBM-Challenges](https://curseforge.com/wow/addons/dbm-challenges)
* [DBM-TimelessIsle](https://curseforge.com/wow/addons/dbm-timeless-isle)
* [DBM-PvP](https://curseforge.com/wow/addons/dbm-pvp)

## Countdown Packs
* [Countpack Overwatch](https://curseforge.com/wow/addons/deadly-boss-mods-dbm-overwatch-countdown-pack)
* [Countpack HoTS](https://curseforge.com/wow/addons/deadly-boss-mods-dbm-heroes-of-the-storm-hots)

## Voice Packs

* [Voicepack VEM (English TTS Female)](https://curseforge.com/wow/addons/dbm-voicepack-vem)
* [Voicepack Yike (Chinese TTS Female)](https://curseforge.com/wow/addons/dbm-voicepack-yike)
* [Voicepack German (German Male)](http://curseforge.com/wow/addons/dbm-voicepack-german)
* [Voicepack Mununyu (Korean Recorded Female)](https://wow.curseforge.com/projects/dbm-voicepack-mununyu)
* [Voicepack Alyona (Russian TTS Female)](https://curseforge.com/wow/addons/dbm-voicepack-russian)
* [Voicepack Italian (Italian TTS Female)](https://curseforge.com/wow/addons/dbm-voicepack-italian)
* [Voicepack Spanish (Spain)](https://wow.curseforge.com/projects/dbm-voicepack-spanish-spain)
* [Voicepack Arnold Schwarzenegger (English Recorded/Spliced)](https://curseforge.com/wow/addons/arnold-schwarzenegger-vem-dbm)
* [Voicepack Draik (English Recorded/Spliced)](https://curseforge.com/wow/addons/dbm-vpdraik)
* [Search for more](https://curseforge.com/wow/addons/search?search=dbm+voice)

## Getting too many updates of DBM per day?
Multiple alpha versions can get pushed to Curse on an average day, these versions may contain important new features or bug fixes for the bleeding edge raid content... These versions are tagged as alpha, so they will not be downloaded by default. Set your Twitch client to update to alpha if you want these latest versions (but they may contain bugs, downloads tagged as "Beta" or "Release" are more stable and released less frequently)
Right click on DBM itself in Twitch client addon list and set to preferred release type to control update frequency.

## Features
* Mods for raid, dungeon, special event and Brawlers Guild
* Colored raid warnings (players will be colored according to their class) with icons and to the point messaging. DBM aims to let you know what to do for something, not just show you a spell name.
* A big focus on filtering/hiding what you don't need to know for your role (or what you can't do anything about such as dispel/interrupt on cooldown), so you can focus on the information you do need, while also maintaining ability to disable these filters for leaders that do want a larger overview of fight events.
* Auto-respond during boss fights. DBM will inform anyone who whispers you during a boss fight that you are busy. These messages contain the name and health of the boss as well as the raid's status. This feature is completely optional and can be disabled by player or even raid leader for the entire group.
* Bars can be enlarged with custom effects when they are about to expire
* Bars that not only show time remaining, but make use of colors and icons to show what type of ability is coming and what role it's for. DBM aims to help you process these bars at a glance.
* Crash/DC recovery: you had a disconnect or crash during a boss fight? No problem for DBM! It will request the timer and combat status information from other DBM users in your raid group and you get your timers back
* Infoframes that is used to show fight overviews or specific mechanics related to fight to help give you need to know information at a quick glance.
* Modular design - all boss mods are plugins and can be exchanged, removed or updated separately
* Load on demand - all boss mods are separate AddOns and they will be loaded when they are needed. So they don't use memory or cpu until you enter the corresponding instance
* Special effects like the screen flash effect, huge warning messages and sounds will draw your attention to critical events with as much customizing of those flashes and sounds as possible to make them effective to your needs.
* Support for SharedMedia, so you can use any texture for your bars and choose sounds from external sources more easily.
* Best possible support for PTR/Beta encounter testing. DBM is only mod to provide cutting edge auto learning timers right in middle of your testing so you know what's coming and when, before anyone has ever even seen the fight before.
* Support for [voice packs](https://curseforge.com/wow/addons/dbm-voicepack-vem) in many different supported languages. Every mod puts careful thought into what the best voice for an alert is that clearly and concisely advices action based on warning. No generic spell name TTS here. DBM voice packs will say something meaningful and not just make more noise for you to ignore.
* Any feature that makes sense to do so has good callbacks that WAs authors can use for best possible [WeakAuras](https://www.wowace.com/projects/weakauras-2) integration.

## Slash Commands
* __/dbm__ - shows/hides the GUI
* __/dbm help__ - Shows all the other slash commands and how to use them.